#!/usr/bin/env python2

import os, datetime

def makedir(dirname):
    print 'Creating directory: ' + dirname
    if not os.path.isdir(dirname):
        os.mkdir(dirname)

def sdm_write_header(dirname, msgcount, msgfrom, msgto, msgsubj, msgdate):
    sdm = open(dirname + os.sep + str(msgcount) + '.msg', 'wb')
    sdm.write(msgfrom.ljust(36, '\0'))
    sdm.write(msgto.ljust(36, '\0'))
    sdm.write(msgsubj.ljust(72, '\0'))
    sdm.write(msgdate.strftime('%d %b %y  %H:%M:%S') + '\0')
    # zero-pad the rest of the header
    sdm.write('\0' * 26)
    sdm.close()
    
def sdm_append_text(dirname, msgcount, text):
    sdm = open(dirname + os.sep + str(msgcount) + '.msg', 'ab')
    sdm.write(text + '\r')
    sdm.close()
    
def main():
    is_header = True
    dirname = '000'
    msgcount = 0
    msgfrom = ''
    msgto = ''
    msgsubj = ''
    msgdate = datetime.datetime(1980, 1, 1)

    f = open('fidonet-messages-execpc.txt')

    s = f.readline()

    if s == '------------------------------\r\n':
        # skip very first line
        s = f.readline()

    while s != '':
        if is_header:
            if s == '\r\n':
                pass
            elif s == 'Next conference: FIDO Message Area\r\n':
                pass
            elif s.startswith('Next topic: '):
                dirname = s[12:].partition(' ')[0]
                makedir(dirname)
                msgcount = 0
            elif s.startswith('FIDO MESSAGE AREA==> TOPIC:'):
                date = s[-10:].rstrip('\r\n')
                try:
                    dt = datetime.datetime.strptime(date, '%m/%d/%y')
                except ValueError:
                    # bad date, set to default
                    dt = datetime.datetime(1980, 1, 1)
            elif s.startswith('From: '):
                msgcount += 1
                time = s[-9:].rstrip('\r\n')
                try:
                    tm = datetime.datetime.strptime(time, '%I:%M%p')
                except ValueError:
                    # bad time, set to midnight
                    msgdate = datetime.datetime(dt.year, dt.month, dt.day, 0, 0, 0)
                finally:
                    msgdate = datetime.datetime(dt.year, dt.month, dt.day, tm.hour, tm.minute, tm.second)
                msgfrom = s[6:60].rstrip()
            elif s.startswith('\\/To: '):
                msgto = s[6:58].rstrip()
            elif s.startswith('Subj: '):
                msgsubj = s[6:].rstrip()[:40]
                # skip next blank line
                s = f.readline()
                is_header = False
                sdm_write_header(dirname, msgcount, msgfrom, msgto, msgsubj, msgdate)
        else:
           s = s.replace('\r\n', '')
           if s == '---------------':
               # EOT
               sdm_append_text(dirname, msgcount, '\0')
               is_header = True
           else:
               # body text
               sdm_append_text(dirname, msgcount, s)
               pass

        s = f.readline()

    f.close()


if __name__ == "__main__":
    main()
